//----------------
// beam class
//----------------
var beamSS = new SpriteSheet({
    images: ["./img/beam.png"],
    frames: {width:200, height:200},
    animations: {
        "default":{
        	frames:[0, 1],
        	speed : 0.5,
        	next:false,
    	}
    }
});

(function() {
	
	//--------------
	// constructor
	//--------------
	var Beam = function() {
		this.initialize(beamSS, "default");
		this.x = -1000;
		this.regX = 140;
		this.regY = 100;
		
		// tick
		this.on("tick", this.tick);
	};
	
	// inherit
	var p = Beam.prototype = new Sprite();
	
	// property
	p.speed = 100;
	p.size = 20;
	p.exist = false;
	p.velocityX = 0;
	p.velocityY = 0;
	
	//--------
	// fire
	//--------
	p.fire = function(inX, inY, inTargetX, inTargetY){
		
		var radian = Math.atan2(inTargetY - inY, inTargetX - inX);
		this.exist = true;
		this.x = inX;
		this.y = inY;
		this.velocityX = Math.cos(radian) * this.speed;
		this.velocityY = Math.sin(radian) * this.speed;
		this.rotation = radian * 180 / Math.PI;
		this.gotoAndPlay("default");
	}
	
	//--------
	// tick
	//--------
	p.tick = function(){
		
		if(this.exist){
			this.x += this.velocityX;
			this.y += this.velocityY;
			
			// out of screen
			if(this.y < -200){
				this.dead();
			}
		}
	}
	
	//--------
	// dead
	//--------
	p.dead = function(){
		this.exist = false;
		this.x = -1000;
	}
	
	// regist
	createjs.Beam = Beam;
}());
