//----------------
// Emitter class
//----------------
var emitterSS = new SpriteSheet({
    images: ["./img/emitter.png"],
    frames: {width:100, height:100},
    animations: {
        "hit":{
        	frames:[1, 2, 3, 0],
        	speed : 0.4,
        	next:false,
    	},
        "explosion":{
        	frames:[4, 5, 6, 0],
        	speed : 0.2,
        	next:false,
    	},
        "smoke":{
        	frames:[7, 8, 9, 0],
        	speed : 0.5,
        	next:false,
    	}
    }
});

(function() {
	
	//--------------
	// constructor
	//--------------
	var Emitter = function() {
		this.initialize(emitterSS, "");
		this.regX = 50;
		this.regY = 50;
		
		// tick
		this.on("tick", this.tick);
	};
	
	// inherit
	var p = Emitter.prototype = new Sprite();
	
	// property
	p.exist = false;
	p.velocityX = 0;
	p.velocityY = 0;
	
	//--------
	// tick
	//--------
	p.tick = function(){
		if(this.exist){
			
			// move
			this.x += this.velocityX;
			this.y += this.velocityY;
			
			// dead
			if(this.currentFrame == 0){
				this.dead();
			}
		}
	}
	
	//-----------
	// put
	//-----------
	p.put = function(inX, inY, inVelX, inVelY, inType, inRotation){
		this.x = inX;
		this.y = inY;
		this.velocityX = inVelX;
		this.velocityY = inVelY;
		this.exist = true;
		this.gotoAndPlay(inType);
		
		if(inRotation){
			this.rotation = Math.random() * 360;
		}else{
			this.rotation = 0;
		}
	}
	
	//--------
	// dead
	//--------
	p.dead = function(){
		this.exist = false;
		this.x = -1000;
	}
	
	// regist
	createjs.Emitter = Emitter;
}());
