//----------------
// tooth class
//----------------
var toothSS = new SpriteSheet({
    images: ["./img/tooth.png"],
    frames: {width:50, height:100},
});

(function() {
	
	//--------------
	// constructor
	//--------------
	var Tooth = function(inNum) {
		this.initialize(toothSS, "");
		this.selfNum = inNum;
		this.x = -1000;
		this.regX = 25;
		this.regY = 25;
		
		// tick
		this.on("tick", this.tick);
		
		// click
		this.on("mousedown", this.launch);
	};
	
	// inherit
	var p = Tooth.prototype = new Sprite();
	
	// property
	p.selfNum = 0;
	p.size = 50;
	p.exist = false;
	p.velocityX = 0;
	p.velocityY = 0;
	p.cnt = 0;
	
	//--------
	// launch
	//--------
	p.launch = function(){
		if(this.exist == false && this.currentFrame == 0 && health > 2){
			this.exist = true;
			fade("#FFF", 0.6, 0.01);
			pullTooth(this.selfNum);
			soundLaunch.play();
		}
	}
	
	//--------
	// tick
	//--------
	p.tick = function(){
		
		if(this.exist){
			this.cnt ++;
			
			this.y += this.velocityY;
			this.velocityY -= 0.1;
			
			//emitter
			if(this.cnt % 4 == 0){
				putEmitter(this.x, this.y + 60, 0, 5, "smoke", false);
			}
			
			// out of screen
			if(this.y < -100){
				this.dead();
			}
		}
	}
	
	//--------
	// dead
	//--------
	p.dead = function(){
		this.exist = false;
		this.x = -1000;
	}
	
	// regist
	createjs.Tooth = Tooth;
}());
